#include "config.h"
#include "cdbslib.h"

//================================================================
// FILESYSTEM LIBRARY
//   Name: patmatch, matchstar
//================================================================

static int matchstar (const char *, const char *);

/* PATMATCH -- Simple filename pattern matching */

int patmatch (const char *pattern, const char *str)
{
    if (*pattern == EOS) 
        return *str == EOS;

    if (*pattern == '*')
        return matchstar (pattern+1, str);

    if (*str != EOS && (*pattern == '?' || *pattern == *str))
	return patmatch (pattern+1, str+1);

    return NO;
}

/* MATCHSTAR -- Match a star within a pattern */

static int matchstar (const char *pattern, const char *str)
{
    do {
        if (patmatch (pattern, str))
	    return YES;
    } while (*str ++ != EOS);

    return NO;
}
